part of cresce_ui;

abstract class CButtonStyle {
  ButtonState getDefaultState();

  ButtonState getTappedState();
}

class CPrimaryStyle implements CButtonStyle {
  const CPrimaryStyle();

  @override
  ButtonState getDefaultState() => UntappedButtonState();

  @override
  ButtonState getTappedState() => TappedButtonState();
}

class CDisabledStyle implements CButtonStyle {
  @override
  ButtonState getDefaultState() => DisabledButtonState();

  @override
  ButtonState getTappedState() => DisabledButtonState();
}

class CSecondaryStyle implements CButtonStyle {
  const CSecondaryStyle();

  @override
  ButtonState getDefaultState() => TappedButtonState();

  @override
  ButtonState getTappedState() => UntappedButtonState();
}

class CAlertStyle implements CButtonStyle {
  const CAlertStyle();

  @override
  ButtonState getDefaultState() => UntappedAlertButtonState();

  @override
  ButtonState getTappedState() => TappedAlertButtonState();
}
